library ieee;
use ieee.std_logic_1164.all;

entity mux2a1 is 
 port(x: in std_logic_vector(1 downto 0);
      sel: in std_logic;
      z: out std_logic);
end mux2a1;

architecture arq1 of mux2a1 is
begin  
  z <= x(0) when sel = '0'
          else x(1);  
end arq1;

architecture arq2 of mux2a1 is
begin  
  process(x, sel)
  begin
     if sel = '0' then
	z <= x(0);
     else
	z <= x(1);
	   end if;
  end process;
end arq2;

--------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_mux2a1 is end test_mux2a1;
architecture test of test_mux2a1 is
signal x: std_logic_vector(1 downto 0) := "00";
signal sel, z: std_logic;
begin
  sel <= '0', '1' after 100 ns, '0' after 300 ns;
  x(0) <= not x(0) after 2 ns;
  x(1) <= not x(1) after 10 ns;
  inst_1: entity work.mux2a1 port map(x, sel, z);
end test;