library ieee;
use ieee.std_logic_1164.all;

entity flipflopSR is
  port(clk, rst, S, R: in std_logic;
       Q: out std_logic);
end flipflopSR;

architecture funcional of flipflopSR is
begin
  process(clk, rst)
    begin
    if rst = '1' then
      Q <= '0';
    elsif rising_edge(clk) then
      if S = '1' then
        Q <= '1';
      elsif R = '1' then
        Q <= '0';
      end if;
    end if;
  end process;
end funcional;

--------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_ffSR is
end test_ffSR;

architecture test of test_ffSR is
signal rst, S, R, Q: std_logic;
signal clk: std_logic :='0';
begin
  inst1: entity work.flipflopSR port map(clk,rst,S,R,Q);
  clk <= not clk after 5 ns;
  rst <= '0', '1' after 10 ns, '0' after 20 ns;
  S <= '0', '1' after 100 ns, '0' after 200 ns;
  R <= '0', '1' after 50 ns, '0' after 150 ns;
end test;