library ieee;
use ieee.std_logic_1164.all;

entity flipflopT is
  port(clk, rst, T: in std_logic;
       Q: out std_logic);
end flipflopT;

architecture funcional of flipflopT is
signal Q_aux: std_logic;
begin
  process(clk,rst)
  begin
    if rst = '1' then
      Q_aux <= '0';
    elsif rising_edge(clk) then
      if T = '1' then
        Q_aux <= not Q_aux;
      end if;
    end if;
  end process;
  Q <= Q_aux;
end funcional;

